package com.xiaoniu.subsystem.business.controller;

import com.alibaba.nacos.common.utils.CollectionUtils;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.xiaoniu.common.core.result.R;
import com.xiaoniu.common.core.utils.BeanUtil;
import com.xiaoniu.common.core.utils.poi.ExcelUtil;
import com.xiaoniu.common.log.annotation.Log;
import com.xiaoniu.common.log.enums.BusinessType;
import com.xiaoniu.subsystem.business.domain.ExamQuestion;
import com.xiaoniu.subsystem.business.domain.GraduationAssessment;
import com.xiaoniu.subsystem.business.domain.PersonnelConfirm;
import com.xiaoniu.subsystem.business.domain.dto.PersonnelConfirmDTO;
import com.xiaoniu.subsystem.business.domain.dto.PersonnelConfirmPageDTO;
import com.xiaoniu.subsystem.business.domain.vo.PersonnelConfirmPageVO;
import com.xiaoniu.subsystem.business.domain.vo.PersonnelConfirmVO;
import com.xiaoniu.subsystem.business.service.IPersonnelConfirmService;
import com.xiaoniu.subsystem.system.domain.Unit;
import com.xiaoniu.subsystem.system.service.IUnitService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.validation.Valid;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import static com.xiaoniu.common.security.utils.SecurityUtils.getUnitId;
import static com.xiaoniu.common.security.utils.SecurityUtils.getUserId;

/**
 * <p>
 * 信息确认表 前端控制器
 * </p>
 *
 * @author haoxuyang
 * @since 2024-12-23 05:36:11
 */
@Slf4j
@AllArgsConstructor
@RestController
@RequestMapping("/personnelConfirm")
@Tag(name = "人员确认表", description = "人员确认")
public class PersonnelConfirmController {
    private final IUnitService unitService;
    private final IPersonnelConfirmService personnelConfirmService;

    /**
     * 详情
     */
    @GetMapping("/detail")
    @ApiOperationSupport(order = 1)
    @Operation(summary = "详情", description = "传入personId")
    public R<PersonnelConfirmVO> detail(@Parameter(description = "主键", required = true) @RequestParam Long personId) {
        PersonnelConfirm detail = personnelConfirmService.getById(personId);
        return R.data(BeanUtil.copy(detail, PersonnelConfirmVO.class));
    }

    /**
     * 分页
     */
    @GetMapping("/page")
    @ApiOperationSupport(order = 2)
    @Operation(summary = "分页", description = "传入PersonnelConfirmPageDTO")
    public R<IPage<PersonnelConfirmPageVO>> page(@Validated  PersonnelConfirmPageDTO dto) {
        IPage<PersonnelConfirm> pages = personnelConfirmService.page(new Page<>(dto.getPageNum(), dto.getPageSize()),
                new LambdaQueryWrapper<PersonnelConfirm>()
                        .orderByDesc(PersonnelConfirm::getCreateTime)
                        .eq( PersonnelConfirm::getFlightId, dto.getFlightId())
                        .like(StringUtils.isNotBlank(dto.getUserName()), PersonnelConfirm::getUserName, dto.getUserName())
                        .eq(StringUtils.isNotBlank(dto.getSex()), PersonnelConfirm::getSex, dto.getSex())
                        .eq(StringUtils.isNotBlank(dto.getQualification()),PersonnelConfirm::getQualification,dto.getQualification())
                        .like(StringUtils.isNotBlank(dto.getSendingUnitName()),PersonnelConfirm::getSendingUnitName,dto.getSendingUnitName())
                        .eq(StringUtils.isNotBlank(dto.getYear()),PersonnelConfirm::getYear,dto.getYear()));

        IPage<PersonnelConfirmPageVO> copy = BeanUtil.copy(pages, PersonnelConfirmPageVO.class);
        return R.data(copy);
    }

    /**
     * 新增
     */
    @PostMapping("/save")
    @ApiOperationSupport(order = 4)
    @Operation(summary = "新增", description = "传入PersonnelConfirmDTO")
    public R save(@Valid @RequestBody PersonnelConfirmDTO dto) {
        Unit unit = unitService.getById(getUnitId());
        PersonnelConfirm copy = BeanUtil.copy(dto, PersonnelConfirm.class)
                .setCreateDept(unit.getUnitId())
                .setCreateUser(getUserId())
                .setCreateTime(new Date());
        List<PersonnelConfirm> one = personnelConfirmService.list(new LambdaQueryWrapper<PersonnelConfirm>()
                .eq(PersonnelConfirm::getFlightId,dto.getFlightId())
                .eq(PersonnelConfirm::getUserName,copy.getUserName())
                .eq(PersonnelConfirm::getIdCard,copy.getIdCard()));
        if (CollectionUtils.isNotEmpty(one)) {
            return R.fail("人员已存在");
        }
        return R.status(personnelConfirmService.save(copy));
    }

    /**
     * 修改
     */
    @PostMapping("/update")
    @ApiOperationSupport(order = 5)
    @Operation(summary = "修改", description = "传入PersonnelConfirmDTO")
    public R update(@Valid @RequestBody PersonnelConfirmDTO dto) {
        PersonnelConfirm copy = BeanUtil.copy(dto, PersonnelConfirm.class)
                .setUpdateUser(getUserId())
                .setUpdateTime(new Date());
        return R.status(personnelConfirmService.updateById(copy));
    }


    /**
     * 删除
     */
    @PostMapping("/remove")
    @ApiOperationSupport(order = 7)
    @Operation(summary = "删除", description = "传入ids")
    public R remove(@Parameter(description = "主键集合", required = true) @RequestParam String ids) {
        List<PersonnelConfirm> list = personnelConfirmService.listByIds(Arrays.stream(ids.split(",")).toList());
        return R.status(personnelConfirmService.removeByIds(Arrays.stream(ids.split(",")).toList()));
    }


    /**
     * 导出
     */
    @GetMapping("/export")
    @ApiOperationSupport(order = 3)
    @Log(title = "导出", businessType = BusinessType.EXPORT)
    @Operation(summary = "导出", description = "传入pageDTO")
    public void export(HttpServletResponse response, @Validated PersonnelConfirmPageDTO dto) {
        List<PersonnelConfirm> list = new ArrayList<>();
        if (StringUtils.isNotBlank(dto.getIds())) {
            list.addAll(personnelConfirmService.list(new LambdaQueryWrapper<PersonnelConfirm>()
                    .orderByDesc(PersonnelConfirm::getCreateTime)
                    .in(StringUtils.isNotBlank(dto.getIds()), PersonnelConfirm::getPersonId,
                            Arrays.stream(dto.getIds().split(",")).toList())));
        } else {
            list.addAll(personnelConfirmService.list(new LambdaQueryWrapper<PersonnelConfirm>()
                    .orderByDesc(PersonnelConfirm::getCreateTime)
                    .eq(null != dto.getFlightId(), PersonnelConfirm::getFlightId, dto.getFlightId())
                    .like(StringUtils.isNotBlank(dto.getUserName()), PersonnelConfirm::getUserName, dto.getUserName())
                    .eq(StringUtils.isNotBlank(dto.getSex()), PersonnelConfirm::getSex, dto.getSex())
                    .eq(StringUtils.isNotBlank(dto.getQualification()),PersonnelConfirm::getQualification,dto.getQualification())
                    .eq(StringUtils.isNotBlank(dto.getSendingUnitName()),PersonnelConfirm::getSendingUnitName,dto.getSendingUnitName())
                    .eq(StringUtils.isNotBlank(dto.getYear()),PersonnelConfirm::getYear,dto.getYear())));
        }
        ExcelUtil<PersonnelConfirm> excelUtil = new ExcelUtil<>(PersonnelConfirm.class);
        excelUtil.exportExcel(response, list, "人员确认信息数据");
    }

    /**
     * 导入
     */
    @PostMapping("/import")
    @ApiOperationSupport(order = 9)
    @Log(title = "人员确认信息导入", businessType = BusinessType.IMPORT)
    @Operation(summary = "导入")
    public R importData(MultipartFile file,
                        @Parameter(description = "是否支持更新", required = true)
                        @RequestParam boolean updateSupport) throws Exception {
        ExcelUtil<PersonnelConfirm> util = new ExcelUtil<>(PersonnelConfirm.class);
        List<PersonnelConfirm> list = util.importExcel(file.getInputStream());
        return R.success(personnelConfirmService.importData(list, updateSupport));
    }

    /**
     * 模版导入
     */
    @GetMapping("/importTemplate")
    @ApiOperationSupport(order = 10)
    @Operation(summary = "导入模版下载")
    public void importTemplate(HttpServletResponse response) {
        ExcelUtil<PersonnelConfirm> util = new ExcelUtil<>(PersonnelConfirm.class);
        util.importTemplateExcel(response, "人员确认信息导入模版");
    }

}
